// module testException.java
// Testet Ausnahme-Behandlung und eigene Exceptions
// E.Huckert 04-2004

public class testException
{
  private int divisor  = 1;
  private int quotient = 0;
  
  // Constructor
  public testException(int divis)
        throws HuException
  {
    System.out.println("Constructor: Divisor=" + divis);
    // Wir fangen beliebige Exceptions ab und
    // erzeugen eine eigene Exception
    try
    {
      System.out.println("Wir teilen " + 12 + " durch " + divis);
      quotient = 12 / divis;
    }
    catch (Exception e)
    {
      System.out.println("Original Exc.Meldung=" + e.getMessage());
      throw new HuException("Division durch 0");
    }
    finally
    {
      // In diesem Beispiel nicht sinnvoll
      System.out.println("im finally Zweig");
    }
  } 

  public static void main(String args[])
  {
    try
    {
      // Hier sollte keine Exception auftreten
      testException te1 = new testException(2);
      // wir provozieren eine Exception
      testException te2 = new testException(0);
    }
    catch (HuException e)
    {
      System.out.println("Meldung der eigenen Exc.Klasse=" + e.getMessage());
      System.out.println("Wegen Exception ist jetzt Schluss");
      e.printStackTrace();
      System.exit(0);
    }
  }
}
