// module Auto.java
// Demonstriert Ableitung von Klassen 
// Demonstriert abstrakte Klassen
// Demonstriert sinnvollen Gebrauch von static
// E.Huckert 11-99
import java.util.*;

abstract class Auto 
{
  protected boolean logging;
  protected String bezeichnung;
  protected double grundsteuer;
  protected int    nummer  = 0;
  public static int anzahl = 0;
 
  // Constructor
  protected Auto()
  {
    grundsteuer = 5.56;
    logging = false;
    bezeichnung = "unbekannt";
    anzahl++;
    System.out.println("In Constructor Auto");
  }

  public void setLogging(boolean flag)
  { logging = flag; }

  public boolean getLogging()
  { return logging; }

  // fortlaufende Exemplarnummer liefern
  int getNummer()
  {  return nummer; }

  public abstract double steuern();

  public abstract String getTyp();
}   // end class Auto

